WPG2Parser Class Reference documentation

Classes | Public Member Functions | Private Member Functions | Private Attributes | List of all members
WPG2Parser Class Reference

`#include <WPG2Parser.h>`

Inheritance diagram for WPG2Parser:

## Classes
class | ObjectCharacterization

## Public Member Functions
| WPG2Parser (librevenge::RVNGInputStream *input, librevenge::RVNGDrawingInterface *painter, bool isEmbedded=false)
bool | parse () override
Public Member Functions inherited from WPGXParser
| WPGXParser (librevenge::RVNGInputStream *input, librevenge::RVNGDrawingInterface *painter)
| WPGXParser (const WPGXParser &parser)
virtual | ~WPGXParser ()
virtual bool | parse ()=0
unsigned char | readU8 ()
unsigned short | readU16 ()
unsigned int | readU32 ()
short | readS16 ()
int | readS32 ()
unsigned int | readVariableLengthInteger ()
WPGXParser & | operator= (const WPGXParser &parser)

## Private Member Functions
void | handleStartWPG ()
void | handleEndWPG ()
void | handleFormSettings ()
void | handleLayer ()
void | handleCompoundPolygon ()
void | handlePenStyleDefinition ()
void | handlePatternDefinition ()
void | handleColorPalette ()
void | handleDPColorPalette ()
void | handlePenForeColor ()
void | handleDPPenForeColor ()
void | handlePenBackColor ()
void | handleDPPenBackColor ()
void | handlePenStyle ()
void | handlePenSize ()
void | handleDPPenSize ()
void | handleLineCap ()
void | handleLineJoin ()
void | handleBrushGradient ()
void | handleDPBrushGradient ()
void | handleBrushForeColor ()
void | handleDPBrushForeColor ()
void | handleBrushBackColor ()
void | handleDPBrushBackColor ()
void | handleBrushPattern ()
void | handlePolyline ()
void | handlePolyspline ()
void | handlePolycurve ()
void | handleRectangle ()
void | handleArc ()
void | handleBitmap ()
void | handleBitmapData ()
void | handleTextData ()
void | handleTextLine ()
void | handleTextBlock ()
void | handleTextPath ()
void | handleObjectCapsule ()
void | handleObjectImage ()
void | resetPalette ()
void | flushCompoundPolygon ()
void | setPenStyle ()
unsigned int | getRemainingRecordLength () const
bool | checkRLESize (unsigned bytes) const
double | toDouble (long x) const
void | transformXY (long &x, long &y) const
void | parseCharacterization (ObjectCharacterization *)

## Private Attributes
int | m_recordLength
long | m_recordEnd
bool | m_success
bool | m_exit
bool | m_graphicsStarted
unsigned int | m_xres
unsigned int | m_yres
long | m_xofs
long | m_yofs
long | m_width
long | m_height
bool | m_doublePrecision
librevenge::RVNGPropertyList | m_style
libwpg::WPGColor | m_penForeColor
libwpg::WPGColor | m_penBackColor
libwpg::WPGColor | m_brushForeColor
libwpg::WPGColor | m_brushBackColor
libwpg::WPGDashArray | m_dashArray
librevenge::RVNGPropertyListVector | m_gradient
std::map< unsigned int, libwpg::WPGDashArray > | m_dashArrayStyles
bool | m_layerOpened
WPG2TransformMatrix | m_matrix
double | m_gradientAngle
librevenge::RVNGPropertyList | m_gradientRef
std::stack< WPGGroupContext > | m_groupStack
WPG2TransformMatrix | m_compoundMatrix
bool | m_compoundWindingRule
bool | m_compoundFilled
bool | m_compoundFramed
bool | m_compoundClosed
WPGBitmapContext | m_bitmap
WPGBinaryDataContext | m_binaryData
bool | m_hFlipped
bool | m_vFlipped
WPGTextDataContext | m_textData
bool | m_drawTextData

## Additional Inherited Members
Protected Attributes inherited from WPGXParser
librevenge::RVNGInputStream * | m_input
librevenge::RVNGDrawingInterface * | m_painter
std::map< int, libwpg::WPGColor > | m_colorPalette

## Constructor & Destructor Documentation

## ◆ WPG2Parser()

WPG2Parser::WPG2Parser | ( | librevenge::RVNGInputStream * | input,
|  | librevenge::RVNGDrawingInterface * | painter,
|  | bool | isEmbedded = `false`
| ) |  |

## Member Function Documentation

## ◆ checkRLESize()

bool WPG2Parser::checkRLESize | ( | unsigned | bytes | ) | const
| private

Referenced by handleBitmapData().

## ◆ flushCompoundPolygon()

void WPG2Parser::flushCompoundPolygon | ( |  | ) |
| private

Referenced by parse().

## ◆ getRemainingRecordLength()

unsigned int WPG2Parser::getRemainingRecordLength | ( |  | ) | const
| private

Referenced by checkRLESize(), handlePenStyleDefinition(), handlePolycurve(), and handlePolyline().

## ◆ handleArc()

void WPG2Parser::handleArc | ( |  | ) |
| private

Referenced by parse().

## ◆ handleBitmap()

void WPG2Parser::handleBitmap | ( |  | ) |
| private

Referenced by parse().

## ◆ handleBitmapData()

void WPG2Parser::handleBitmapData | ( |  | ) |
| private

Referenced by parse().

## ◆ handleBrushBackColor()

void WPG2Parser::handleBrushBackColor | ( |  | ) |
| private

Referenced by parse().

## ◆ handleBrushForeColor()

void WPG2Parser::handleBrushForeColor | ( |  | ) |
| private

Referenced by parse().

## ◆ handleBrushGradient()

void WPG2Parser::handleBrushGradient | ( |  | ) |
| private

Referenced by parse().

## ◆ handleBrushPattern()

void WPG2Parser::handleBrushPattern | ( |  | ) |
| private

Referenced by parse().

## ◆ handleColorPalette()

void WPG2Parser::handleColorPalette | ( |  | ) |
| private

Referenced by parse().

## ◆ handleCompoundPolygon()

void WPG2Parser::handleCompoundPolygon | ( |  | ) |
| private

Referenced by parse().

## ◆ handleDPBrushBackColor()

void WPG2Parser::handleDPBrushBackColor | ( |  | ) |
| private

Referenced by parse().

## ◆ handleDPBrushForeColor()

void WPG2Parser::handleDPBrushForeColor | ( |  | ) |
| private

Referenced by parse().

## ◆ handleDPBrushGradient()

void WPG2Parser::handleDPBrushGradient | ( |  | ) |
| private

Referenced by parse().

## ◆ handleDPColorPalette()

void WPG2Parser::handleDPColorPalette | ( |  | ) |
| private

Referenced by parse().

## ◆ handleDPPenBackColor()

void WPG2Parser::handleDPPenBackColor | ( |  | ) |
| private

Referenced by parse().

## ◆ handleDPPenForeColor()

void WPG2Parser::handleDPPenForeColor | ( |  | ) |
| private

Referenced by parse().

## ◆ handleDPPenSize()

void WPG2Parser::handleDPPenSize | ( |  | ) |
| private

Referenced by parse().

## ◆ handleEndWPG()

void WPG2Parser::handleEndWPG | ( |  | ) |
| private

Referenced by handleStartWPG(), and parse().

## ◆ handleFormSettings()

void WPG2Parser::handleFormSettings | ( |  | ) |
| private

Referenced by parse().

## ◆ handleLayer()

void WPG2Parser::handleLayer | ( |  | ) |
| private

Referenced by parse().

## ◆ handleLineCap()

void WPG2Parser::handleLineCap | ( |  | ) |
| private

Referenced by parse().

## ◆ handleLineJoin()

void WPG2Parser::handleLineJoin | ( |  | ) |
| private

Referenced by parse().

## ◆ handleObjectCapsule()

void WPG2Parser::handleObjectCapsule | ( |  | ) |
| private

Referenced by parse().

## ◆ handleObjectImage()

void WPG2Parser::handleObjectImage | ( |  | ) |
| private

Referenced by parse().

## ◆ handlePatternDefinition()

void WPG2Parser::handlePatternDefinition | ( |  | ) |
| private

Referenced by parse().

## ◆ handlePenBackColor()

void WPG2Parser::handlePenBackColor | ( |  | ) |
| private

Referenced by parse().

## ◆ handlePenForeColor()

void WPG2Parser::handlePenForeColor | ( |  | ) |
| private

Referenced by parse().

## ◆ handlePenSize()

void WPG2Parser::handlePenSize | ( |  | ) |
| private

Referenced by parse().

## ◆ handlePenStyle()

void WPG2Parser::handlePenStyle | ( |  | ) |
| private

Referenced by parse().

## ◆ handlePenStyleDefinition()

void WPG2Parser::handlePenStyleDefinition | ( |  | ) |
| private

Referenced by parse().

## ◆ handlePolycurve()

void WPG2Parser::handlePolycurve | ( |  | ) |
| private

Referenced by parse().

## ◆ handlePolyline()

void WPG2Parser::handlePolyline | ( |  | ) |
| private

Referenced by handlePolyspline(), and parse().

## ◆ handlePolyspline()

void WPG2Parser::handlePolyspline | ( |  | ) |
| private

Referenced by parse().

## ◆ handleRectangle()

void WPG2Parser::handleRectangle | ( |  | ) |
| private

Referenced by parse().

## ◆ handleStartWPG()

void WPG2Parser::handleStartWPG | ( |  | ) |
| private

Referenced by parse().

## ◆ handleTextBlock()

void WPG2Parser::handleTextBlock | ( |  | ) |
| private

Referenced by parse().

## ◆ handleTextData()

void WPG2Parser::handleTextData | ( |  | ) |
| private

Referenced by parse().

## ◆ handleTextLine()

void WPG2Parser::handleTextLine | ( |  | ) |
| private

Referenced by parse().

## ◆ handleTextPath()

void WPG2Parser::handleTextPath | ( |  | ) |
| private

Referenced by parse().

## ◆ parse()

bool WPG2Parser::parse | ( |  | ) |
| overridevirtual

Implements WPGXParser.

## ◆ parseCharacterization()

void WPG2Parser::parseCharacterization | ( | ObjectCharacterization * | ch | ) |
| private

Referenced by handleArc(), handleBitmap(), handleCompoundPolygon(), handleObjectCapsule(), handlePolycurve(), handlePolyline(), handleRectangle(), handleTextBlock(), and handleTextLine().

## ◆ resetPalette()

void WPG2Parser::resetPalette | ( |  | ) |
| private

Referenced by WPG2Parser().

## ◆ setPenStyle()

void WPG2Parser::setPenStyle | ( |  | ) |
| private

Referenced by handlePenStyle().

## ◆ toDouble()

double WPG2Parser::toDouble | ( | long | x | ) | const
| private

Referenced by handleArc(), handleBitmap(), handleBrushForeColor(), handleDPBrushForeColor(), handleDPPenSize(), handleFormSettings(), handleObjectCapsule(), handlePenSize(), handlePenStyleDefinition(), handlePolycurve(), handlePolyline(), handleRectangle(), handleStartWPG(), handleTextBlock(), and handleTextLine().

## ◆ transformXY()

void WPG2Parser::transformXY | ( | long & | x,
|  | long & | y
| ) |  | const
| private

Referenced by handleArc(), handleBitmap(), handleObjectCapsule(), handlePolycurve(), handlePolyline(), handleRectangle(), handleTextBlock(), and handleTextLine().

## Member Data Documentation

## ◆ m_binaryData

WPGBinaryDataContext WPG2Parser::m_binaryData
| private

Referenced by handleObjectCapsule(), and handleObjectImage().

## ◆ m_bitmap

WPGBitmapContext WPG2Parser::m_bitmap
| private

Referenced by handleBitmap(), and handleBitmapData().

## ◆ m_brushBackColor

libwpg::WPGColor WPG2Parser::m_brushBackColor
| private

Referenced by handleBrushBackColor(), handleDPBrushBackColor(), and WPG2Parser().

## ◆ m_brushForeColor

libwpg::WPGColor WPG2Parser::m_brushForeColor
| private

Referenced by handleBrushBackColor(), handleBrushForeColor(), handleDPBrushBackColor(), handleDPBrushForeColor(), and WPG2Parser().

## ◆ m_compoundClosed

bool WPG2Parser::m_compoundClosed
| private

Referenced by handleCompoundPolygon(), and parse().

## ◆ m_compoundFilled

bool WPG2Parser::m_compoundFilled
| private

Referenced by handleCompoundPolygon(), and parse().

## ◆ m_compoundFramed

bool WPG2Parser::m_compoundFramed
| private

Referenced by handleCompoundPolygon(), and parse().

## ◆ m_compoundMatrix

WPG2TransformMatrix WPG2Parser::m_compoundMatrix
| private

Referenced by handleCompoundPolygon(), and parse().

## ◆ m_compoundWindingRule

bool WPG2Parser::m_compoundWindingRule
| private

Referenced by handleCompoundPolygon().

## ◆ m_dashArray

libwpg::WPGDashArray WPG2Parser::m_dashArray
| private

Referenced by handlePenStyle(), setPenStyle(), and WPG2Parser().

## ◆ m_dashArrayStyles

std::map<unsigned int,libwpg::WPGDashArray> WPG2Parser::m_dashArrayStyles
| private

Referenced by handlePenStyle(), handlePenStyleDefinition(), and handleStartWPG().

## ◆ m_doublePrecision

bool WPG2Parser::m_doublePrecision
| private

Referenced by handleArc(), handleBitmap(), handleDPBrushBackColor(), handleDPBrushForeColor(), handleDPPenBackColor(), handleDPPenForeColor(), handleFormSettings(), handleObjectCapsule(), handlePenStyleDefinition(), handlePolycurve(), handlePolyline(), handleRectangle(), handleStartWPG(), handleTextBlock(), handleTextLine(), and toDouble().

## ◆ m_drawTextData

bool WPG2Parser::m_drawTextData
| private

Referenced by handleTextBlock(), handleTextData(), handleTextLine(), and handleTextPath().

## ◆ m_exit

bool WPG2Parser::m_exit
| private

Referenced by handleEndWPG(), handleStartWPG(), and parse().

## ◆ m_gradient

librevenge::RVNGPropertyListVector WPG2Parser::m_gradient
| private

Referenced by flushCompoundPolygon(), handleArc(), handleBrushForeColor(), handleDPBrushForeColor(), handlePolycurve(), handlePolyline(), and handleRectangle().

## ◆ m_gradientAngle

double WPG2Parser::m_gradientAngle
| private

Referenced by handleBrushForeColor(), handleBrushGradient(), handleDPBrushForeColor(), and handleDPBrushGradient().

## ◆ m_gradientRef

librevenge::RVNGPropertyList WPG2Parser::m_gradientRef
| private

Referenced by handleBrushForeColor(), handleBrushGradient(), handleDPBrushForeColor(), and handleDPBrushGradient().

## ◆ m_graphicsStarted

bool WPG2Parser::m_graphicsStarted
| private

Referenced by flushCompoundPolygon(), handleArc(), handleBitmap(), handleBitmapData(), handleBrushBackColor(), handleBrushForeColor(), handleBrushGradient(), handleBrushPattern(), handleColorPalette(), handleCompoundPolygon(), handleDPBrushBackColor(), handleDPBrushForeColor(), handleDPBrushGradient(), handleDPColorPalette(), handleDPPenBackColor(), handleDPPenForeColor(), handleDPPenSize(), handleEndWPG(), handleLayer(), handleLineCap(), handleLineJoin(), handleObjectCapsule(), handleObjectImage(), handlePatternDefinition(), handlePenBackColor(), handlePenForeColor(), handlePenSize(), handlePenStyle(), handlePenStyleDefinition(), handlePolycurve(), handlePolyline(), handlePolyspline(), handleRectangle(), handleStartWPG(), handleTextBlock(), handleTextData(), handleTextLine(), and handleTextPath().

## ◆ m_groupStack

std::stack<WPGGroupContext> WPG2Parser::m_groupStack
| private

Referenced by flushCompoundPolygon(), handleBrushBackColor(), handleBrushForeColor(), handleBrushGradient(), handleBrushPattern(), handleDPBrushBackColor(), handleDPBrushForeColor(), handleDPBrushGradient(), handleDPPenBackColor(), handleDPPenForeColor(), handleDPPenSize(), handleLineCap(), handleLineJoin(), handlePenBackColor(), handlePenForeColor(), handlePenSize(), handlePenStyle(), handlePolycurve(), handlePolyline(), and parse().

## ◆ m_height

long WPG2Parser::m_height
| private

Referenced by handleStartWPG(), and transformXY().

## ◆ m_hFlipped

bool WPG2Parser::m_hFlipped
| private

Referenced by handleBitmap(), and handleBitmapData().

## ◆ m_layerOpened

bool WPG2Parser::m_layerOpened
| private

Referenced by handleEndWPG(), and handleLayer().

## ◆ m_matrix

WPG2TransformMatrix WPG2Parser::m_matrix
| private

Referenced by handleArc(), handleBitmap(), handleObjectCapsule(), handlePolycurve(), handlePolyline(), handleRectangle(), handleTextBlock(), handleTextLine(), and transformXY().

## ◆ m_penBackColor

libwpg::WPGColor WPG2Parser::m_penBackColor
| private

Referenced by handleDPPenBackColor(), handlePenBackColor(), and WPG2Parser().

## ◆ m_penForeColor

libwpg::WPGColor WPG2Parser::m_penForeColor
| private

Referenced by handleDPPenBackColor(), handleDPPenForeColor(), handlePenBackColor(), handlePenForeColor(), and WPG2Parser().

## ◆ m_recordEnd

long WPG2Parser::m_recordEnd
| private

Referenced by getRemainingRecordLength(), handleBitmapData(), handleObjectCapsule(), handleObjectImage(), handleTextData(), and parse().

## ◆ m_recordLength

int WPG2Parser::m_recordLength
| private

Referenced by parse().

## ◆ m_style

librevenge::RVNGPropertyList WPG2Parser::m_style
| private

Referenced by flushCompoundPolygon(), handleArc(), handleBrushBackColor(), handleBrushForeColor(), handleDPBrushBackColor(), handleDPBrushForeColor(), handleDPPenBackColor(), handleDPPenForeColor(), handleDPPenSize(), handlePenBackColor(), handlePenForeColor(), handlePenSize(), handlePenStyle(), handlePolycurve(), handlePolyline(), handleRectangle(), setPenStyle(), and WPG2Parser().

## ◆ m_success

bool WPG2Parser::m_success
| private

Referenced by handleStartWPG(), and parse().

## ◆ m_textData

WPGTextDataContext WPG2Parser::m_textData
| private

Referenced by handleTextBlock(), handleTextData(), and handleTextLine().

## ◆ m_vFlipped

bool WPG2Parser::m_vFlipped
| private

Referenced by handleBitmap(), and handleBitmapData().

## ◆ m_width

long WPG2Parser::m_width
| private

Referenced by handleStartWPG().

## ◆ m_xofs

long WPG2Parser::m_xofs
| private

Referenced by handleStartWPG(), and transformXY().

## ◆ m_xres

unsigned int WPG2Parser::m_xres
| private

Referenced by handleArc(), handleBitmap(), handleDPPenSize(), handleFormSettings(), handleObjectCapsule(), handlePenSize(), handlePolycurve(), handlePolyline(), handleRectangle(), handleStartWPG(), handleTextBlock(), and handleTextLine().

## ◆ m_yofs

long WPG2Parser::m_yofs
| private

Referenced by handleStartWPG(), and transformXY().

## ◆ m_yres

unsigned int WPG2Parser::m_yres
| private

Referenced by handleArc(), handleBitmap(), handleFormSettings(), handleObjectCapsule(), handlePolycurve(), handlePolyline(), handleRectangle(), handleStartWPG(), handleTextBlock(), and handleTextLine().

The documentation for this class was generated from the following files:

- WPG2Parser.h
- WPG2Parser.cpp